# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from logit import logit

from config.models import HotQueryInfo, HotRecommendInfo
from utils.error.response_utils import response


@logit
def hot_recommend_list_api(request):
    hots = HotRecommendInfo.objects.filter(status=True)
    hots = [hot.data for hot in hots]

    return response(200, 'Get Hot Recommend List Success', u'获取热门推荐列表成功', {
        'hots': hots,
    })


@logit
def hot_query_list_api(request):
    querys = HotQueryInfo.objects.filter(status=True)
    querys = [query.data for query in querys]

    return response(200, 'Get Hot Query List Success', u'获取热门搜索列表成功', {
        'querys': querys,
    })
